<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/matcreateseqadj.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>matcreateseqadj.c</h1><a href="matcreateseqadj_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2006-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: matcreateseqadj.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="matcreateseqadj_8c.html#ae33fb5e4bf8cbe9e2361e84f29a77d35">00027</a> <span class="preprocessor">#define PREALLOC_DG 20</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="util_8h.html#ab33e9faf6d36edfbfd51050078ab25a0">00030</a> <span class="keywordtype">int</span> <a class="code" href="matcreateseqadj_8c.html#a75401ceb9e40834d9b15671f96a9c03a">matcreateseqadj</a>(<span class="keywordtype">int</span> nvert,<span class="keywordtype">int</span> nele,<span class="keywordtype">int</span> *elevert,Mat *matout)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordtype">int</span> *ia,*ja;
<a name="l00035"></a>00035   ierr = <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(nele,nvert,elevert,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">/* calculate number of nonzeroes for each line */</span>
<a name="l00038"></a>00038   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;nvert;i++) {
<a name="l00039"></a>00039     ia[i]=ia[i+1]-ia[i]+1;
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">/* create matrix mat */</span>
<a name="l00043"></a>00043   Mat mat;
<a name="l00044"></a>00044   ierr = MatCreateSeqAIJ(
<a name="l00045"></a>00045     PETSC_COMM_SELF,
<a name="l00046"></a>00046     nvert,nvert,
<a name="l00047"></a>00047     0,ia,
<a name="l00048"></a>00048 <span class="comment">/*</span>
<a name="l00049"></a>00049 <span class="comment">    PREALLOC_DG,PETSC_NULL,</span>
<a name="l00050"></a>00050 <span class="comment">*/</span>
<a name="l00051"></a>00051     &amp;mat
<a name="l00052"></a>00052   );CHKERRQ(ierr);
<a name="l00053"></a>00053   ierr = MatSetFromOptions(mat);CHKERRQ(ierr);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   ierr = PetscFree(ia);CHKERRQ(ierr);
<a name="l00056"></a>00056   ierr = PetscFree(ja);CHKERRQ(ierr);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nele; i++) {
<a name="l00059"></a>00059     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0;l&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;l++) {
<a name="l00060"></a>00060       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;NV;j++) {
<a name="l00061"></a>00061         <span class="comment">/* set stiffness matrix element */</span>
<a name="l00062"></a>00062         ierr = MatSetValue(
<a name="l00063"></a>00063           mat,
<a name="l00064"></a>00064           elevert[i*NV+j],
<a name="l00065"></a>00065           elevert[i*NV+l],
<a name="l00066"></a>00066           1.0,
<a name="l00067"></a>00067           ADD_VALUES
<a name="l00068"></a>00068         );CHKERRQ(ierr);
<a name="l00069"></a>00069       } <span class="comment">/* end for j loop */</span>
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071   }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   PetscInfo(0,<span class="stringliteral">&quot;mat matrix assembly complete\n&quot;</span>);
<a name="l00074"></a>00074   ierr = MatAssemblyBegin(mat,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00075"></a>00075   ierr = MatAssemblyEnd(mat,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   *matout=mat;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

